;**************************************************************
;*	CFU Bewegung
;*  Dupliziert die aktive Ebene und
;*	Bewegt diese Ebene bzw. eine Ebenenmaske
;*	Geschrieben fr GIMP 2.6
;*
;*	Einstellbare Parameter:
;*	"Was soll bewegt werden"                       
;*	"Anzahl der Bewegungen (Ebenen)"                     
;*	"Horizontale Bewegung in Pixel"                 
;*	"Vertikale Bewegung in Pixel"                   
;*	"Rotation"     
;*	"Winkel"                                           
;*	"Bild-Mittelpunkt benutzen"                                     
;*	"Mittelpunkt (x-Koordinate)"                  
;*	"Mittelpunkt (y-Koordinate)"                 
;*	"Eventuelle Ebenenmaske anwenden"                                  
;*	"Ebenen zusammenfassen"                                             
;*	"Auswahl beibehalten"                                               
;*	"Neues Bild erstellen"                                               
;*
;**************************************************************

(define (script-fu-cf-tools-bewegung-01 
						inBild 
						inEbene 
						inWas 
						inSteps 
						inHor 
						inVer
						inRotation
						inWinkel
						inDrehpunkt
						inRotX
						inRotY
						inMaskeAnwenden
						inEbenenVereinen
						inAuswahlBehalten 
						inNeuesBild
				)

	(let* (	
		(counter 0)
		(zaehler 0)
    (outBild 			(cond ((= inNeuesBild TRUE)
                  	    	(car (gimp-image-duplicate inBild)))
                    		((= inNeuesBild FALSE)
                      		inBild)))
		(actDraw 	 		(car (gimp-image-get-active-drawable outBild)))
		(newLayer 	 	(car (gimp-image-get-active-layer outBild)))
		(oldLayer 	 	(car (gimp-image-get-active-layer outBild)))
		(orgLayer			(car (gimp-image-get-active-layer outBild)))
		(isMaskID			(car (gimp-layer-get-mask newLayer)))
		(isMask 			FALSE)
		(isMaskAct	 	FALSE)
		(isMaskMov		FALSE)
		(WinkelGrad 0)
		(StartWinkel 0)
		(WinkelRadiant 0)
		(imageWidth  	(car (gimp-image-width outBild)))
		(imageHeight  (car (gimp-image-height outBild)))
 	      )
 
		(set! orgLayer (car(gimp-layer-new-from-drawable orgLayer outBild)))

 		(cond ((= inRotation 0))
 		      ((= inRotation 1)
 		      	(set! StartWinkel inWinkel))
 		      ((= inRotation 2)
 		      	(set! StartWinkel (/ 90 inSteps)))
 		      ((= inRotation 3)
 		      	(set! StartWinkel (/ 180 inSteps)))
 		      ((= inRotation 4)
 		      	(set! StartWinkel (/ 270 inSteps)))
 		      ((= inRotation 5)
 		      	(begin
 		      		(set! StartWinkel (/ 360 inSteps)))
 		      		(set! inSteps (- inSteps 1))
 		      	)
 		      ((= inRotation 6)
 		      	(set! StartWinkel (/ 360 inSteps)))
 		)
 
		(set! WinkelRadiant (* StartWinkel (/ 3.14159 180)))
 	      
 	 	(if (= inDrehpunkt 0)
    	(begin 
				(set! inRotX (/ imageWidth 2))
				(set! inRotY (/ imageHeight 2))
			)
		)	
 	      
		(gimp-undo-push-group-start outBild)

		(if (= inAuswahlBehalten FALSE)
			(gimp-selection-none outBild)) 
			
		(gimp-drawable-set-visible actDraw TRUE)

		(if (<> isMaskID -1)
    	(begin 
				(set! isMask TRUE)
    	)
		)	

		(if (= isMask TRUE)
    	(begin 
				(set! isMaskAct (car (gimp-drawable-is-layer-mask inEbene)))
				(gimp-layer-set-edit-mask newLayer FALSE)
				(if (= inWas 1)
  	  		(begin 
						(set! isMaskMov TRUE)
					)
				)
			)
		)	

		(gimp-layer-resize-to-image-size newLayer)
		(set! newLayer (car(gimp-layer-new-from-drawable newLayer outBild)))

    (if   (and (= inMaskeAnwenden TRUE) (= isMask TRUE))
         	(gimp-layer-remove-mask oldLayer MASK-APPLY)
    )

  	(while (< counter inSteps) 
    	(begin 
    	
    		(set! zaehler (+ counter 1))

 				(gimp-image-add-layer outBild newLayer -1)               
 				
				(if (= isMaskMov TRUE)
					(gimp-layer-set-edit-mask newLayer TRUE)
				)	

				(set! actDraw (car(gimp-image-get-active-drawable outBild)))

				(if (= isMaskMov FALSE)
					(begin
						(set! WinkelGrad (* WinkelRadiant zaehler))

						(gimp-drawable-transform-rotate-default 
								newLayer 
								WinkelGrad 
								FALSE 
								inRotX 
								inRotY 
								FALSE 
								FALSE)

						(gimp-layer-resize-to-image-size newLayer)				
						(gimp-layer-translate newLayer (* zaehler inHor)  (* zaehler inVer))
					)
					(begin
						(set! WinkelGrad (* WinkelRadiant zaehler))
						(gimp-drawable-transform-rotate-default 
								actDraw 
								WinkelGrad 
								FALSE 
								inRotX 
								inRotY 
								FALSE 
								FALSE)
						(gimp-layer-resize-to-image-size newLayer)				
						(gimp-drawable-offset actDraw TRUE 0 (* zaehler inHor)  (* zaehler inVer))
						(gimp-layer-set-edit-mask newLayer FALSE)
					)
				)

				(gimp-layer-resize-to-image-size newLayer)				
				(set! oldLayer newLayer)
				(set! newLayer (car(gimp-layer-new-from-drawable orgLayer outBild)))
						
    		(cond ((= inEbenenVereinen TRUE)
               	(gimp-image-merge-down outBild oldLayer EXPAND-AS-NECESSARY))
              ((and (= inMaskeAnwenden TRUE) (= isMask TRUE))
             	(gimp-layer-remove-mask oldLayer MASK-APPLY))
        )
				
				(set! counter (+ counter 1))    
			)
 		)

		(if (= isMaskAct TRUE)
			(gimp-layer-set-edit-mask newLayer TRUE)
		)	

		(gimp-undo-push-group-end outBild)

  	(if (= inNeuesBild TRUE)
  		(gimp-display-new outBild)
	  )
		(gimp-displays-flush)
 	)
)

 
	(script-fu-register
		"script-fu-cf-tools-bewegung-01"          ;Name der Funktion, die aufgerufen werden soll
		"Ebene/-nmasken Bewegung"		                        ;Namentsewe des Skripts
		"Bewegt eine Ebene bzw. eine Ebenenmaske" ;Beschreibung des Skripts
		"CF"                                     	;Name des Autors
		"Copyleft by CF"                         	;Copyright-Infos
		"21.01.2012"                             	;Datum
		"RGB* GRAY* INDEXED*"                     ;
		SF-IMAGE "Das Bild" 0
		SF-DRAWABLE "Die Ebene" 0
 		SF-OPTION "Was soll bewegt werden"     '("Ebene" "Ebenenmaske")
 		SF-ADJUSTMENT "Anzahl der Bewegungen (Ebenen)"     '(12 1 500 1 10 0 0)
 		SF-ADJUSTMENT "Horizontale Bewegung in Pixel"    '(0 -999 999 1 10 0 0)
 		SF-ADJUSTMENT "Vertikale Bewegung in Pixel"      '(0 -999 999 1 10 0 0)
 		SF-OPTION "Rotation"     '(	"Keine" 
 																"Winkel" 
 																"90 Grad" 
 																"180 Grad" 
 																"270 Grad" 
 																"360 Grad ohne Endebild"
 																"360 Grad mit Endebild"
 																)
 		SF-ADJUSTMENT "Winkel"    '(0 -360 360 1 10 1 0)
 		SF-OPTION 		"Drehen um"     '("Bild-Mittelpunkt" "Freier Punkt")
 		SF-ADJUSTMENT "Mittelpunkt (x-Koordinate)"    '(400 -999 99999 1 10 0 0)
 		SF-ADJUSTMENT "Mittelpunkt (y-Koordinate)"    '(400 -999 99999 1 10 0 0)
		SF-TOGGLE     "Eventuelle Ebenenmaske anwenden" FALSE
		SF-TOGGLE     "Ebenen zusammenfassen" FALSE
		SF-TOGGLE     "Auswahl beibehalten" FALSE
		SF-TOGGLE     "Neues Bild erstellen" TRUE
	)

	(script-fu-menu-register "script-fu-cf-tools-bewegung-01" "<Image>/Meine Skripte/Helferlein")		
